# frozen_string_literal: true

require 'active_model'
require 'json'

module Yade
  module Common
    module Model
      # authentication
      class Authentication
        include ActiveModel::Model
        include ActiveModel::Validations
        include ActiveModel::Serializers::JSON

        attr_accessor :auth_url, :auth_username, :auth_password, :access_token,
                      :refresh_token, :expiration_time

        validates_presence_of 'auth_url', 'auth_username', 'auth_password', 'access_token', 'refresh_token',
                              'expiration_time'

        def attributes
          instance_values
        end

        # write
        def write
          json = as_json.to_json

          File.open("#{ENV['HOME']}/.yade/authentication.json", 'w') do |f|
            f.write(json)
          end
        end

        # read
        def read
          from_json(File.read("#{ENV['HOME']}/.yade/authentication.json"))
        end
      end
    end
  end
end
